#ifndef CPP_DATASTRUCTURES_STRINGARRAY_H
#define CPP_DATASTRUCTURES_STRINGARRAY_H

// Eine Arrayliste fr Stringpointer
//
// Autor: Jochen Becher
//
// Historie:
// Version 1.0 am 25. Juni 94

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif

#ifndef CPP_DATASTRUCTURES_GENARRAYLIST_H
#include <classes/datastructures/genarraylist.h>
#endif

class stringarray {
friend class stringarraycursor;
public:
	stringarray(STRPTR string1, ...) throw (MemoryX);
	stringarray(STRPTR *strings = NULL) throw (MemoryX);
	ULONG length() const;
	STRPTR *strings();
	STRPTR &operator[] (ULONG index) throw (MemoryX);
	VOID addTail(STRPTR str) throw (MemoryX);
	VOID insert(STRPTR str, ULONG index) throw (MemoryX);
	VOID remTail();
	VOID remove(ULONG index) throw (MemoryX);
private:
	gen_arraylist strs;
};

class stringarraycursor : public gen_arraycursor {
public:
	stringarraycursor(stringarray &);
	STRPTR item() throw (MemoryX);
};

#endif
